// Josh Cogliati
#define QUESTIONLEN 1024
#define ANSWERLEN 1024
#define HINTLEN 1024
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dc.h>
#include <stdio.h>
#include <stdlib.h>
#include <owl\dialog.h>
#include <classlib/arrays.h>
#include <owl\opensave.h>
#include <owl\inputdia.h>
#include <strstrea.h>
#include <owl\edit.h>
#include <owl\button.h>
#include <owl\checkbox.h>
#include <owl\radiobut.h>
#include <owl\printer.h>
#include <cstring.h>
#include "textprnt.h"
#include <string.h>
//#include <constrea.h>
#include "study.rh"


class Study_Data {
	public:
	string  question;
	string  answer;
	string  hint;
	char  delimit;
	bool  ishint;
	bool  ccorrect;
	bool  cwhite;
	bool  cases;
	int  boolean;
	bool  operator ==(const Study_Data& other) const
	{
		return &other == this;
	}
	//bool checkans(string other);
	Study_Data&  operator = (const Study_Data& other) {
		question=other.question;
		answer=other.answer;
		hint=other.hint;
		delimit=other.delimit;
		ishint=other.ishint;
		ccorrect=other.ccorrect;
		cwhite=other.cwhite;
		cases=other.cases;
		boolean=other.boolean;
		return *this;
	}
	friend ostream& operator <<(ostream& os, const Study_Data& data4);
	friend ifstream& operator >>(ifstream& is, Study_Data& data4);

};

typedef  TArray<Study_Data> dat;
typedef  TArrayIterator<Study_Data> datint;

dat qdt(10,1,10);

string OFileName,NFileName;

string stringreplace(const string target,const string find,const string replace){
	size_t endkeep=0,startkeep=0;
	string ret;
	endkeep=target.find_first_of(find);
	while(endkeep!=NPOS){
		ret.append(target.substr(startkeep,endkeep-startkeep));
		ret.append(replace);
		startkeep=endkeep+find.length();
		endkeep=target.find_first_of(find,startkeep);
	};
	ret.append(target.substr(startkeep));
	return ret;
};

ostream& operator <<(ostream& os,const Study_Data& data5)
{
	char buf[ANSWERLEN + HINTLEN + QUESTIONLEN+20];
	ostrstream tstr(buf,sizeof buf );
	tstr <<'\t'<<data5.question<<'\t'<<data5.answer<<'\t'<<data5.hint<<'\t'<<data5.delimit;
	tstr <<data5.ishint<<' '<<data5.ccorrect<<' '<<data5.cwhite<<' '<<data5.cases<<' '<<data5.boolean<<ends;
	return os << buf;
};

ifstream& operator >>(ifstream& is, Study_Data& data5)
{
	char buf1[5];
	char buf2[5];
	char buf3[5];
	char buf4[5];
	char buf5[5];
	char buf6[5];
	//char qbuf[QUESTIONLEN];
	//char abuf[ANSWERLEN];
	//char hbuf[HINTLEN];
	//is.getline(qbuf,QUESTIONLEN,'\t');
	getline(is,data5.question,'\t');
	//data5.question=string(qbuf);
	getline(is,data5.answer,'\t');
	//data5.answer=string(abuf);
	getline(is,data5.hint,'\t');
	//data5.hint=string(hbuf);
	is.getline(buf6,5,'\t');
	data5.delimit=buf6[0];
	is.getline(buf1,5,'\t');
	data5.ishint=atoi(buf1);
	is.getline(buf2,5,'\t');
	data5.ccorrect=atoi(buf2);
	is.getline(buf3,5,'\t');
	data5.cwhite=atoi(buf3);
	is.getline(buf4,5,'\t');
	data5.cases=atoi(buf4);
	is.getline(buf5,5,'\t');
	data5.boolean=atoi(buf5);
	return is;
};

void OpenFile(){
	ifstream is(OFileName.c_str());

	if (!is)
	 printf("Unable to open file");//, "File Error", MB_OK | MB_ICONEXCLAMATION);
	else {
	 qdt.Flush();
	 unsigned  numquestions;
	 char tem43[2];
	 is >> numquestions;
	 is.getline(tem43,2);
	 while (numquestions--) {
		Study_Data quest;
		is >> quest;
		qdt.Add(quest);
		}
	}

	//IsNewFile = false;
	//IsDirty = false;
};
void SaveFile(){
	ofstream os(NFileName.c_str());

	if (!os)
	 printf("Unable to open file");//, "File Error", MB_OK | MB_ICONEXCLAMATION);
	else {
	 os << qdt.GetItemsInContainer() << '\n';
	 datint  i(qdt);
	 while (i)
		os << i++;
	 //IsNewFile = false;
	 //IsDirty = false;
	}
};


void main(){
	cout << "Input the file name to convert from\n";
	cin>>OFileName;
	cout<<"Opening File: "<<OFileName;
	OpenFile();
	cout << "\nInput the file name to save to\n";
	cin>>NFileName;
	cout<<"Saving File: "<<NFileName;
  SaveFile();

};